//
//  PongTutorialViewController.m
//  PongTutorial
//
//  Created by Andrea Busi on 08/03/09.
//  Copyright "BubiDevs" 2009. All rights reserved.
//

#import "PongTutorialViewController.h"

//stato della partita
#define kPartitaInCorso 1
#define kPartitaFerma 2

//velocità della pallina sui due assi
#define kVelocitaPallaX 10
#define kVelocitaPallaY 20

@implementation PongTutorialViewController

@synthesize barraUno, barraDue, pallina, textInizia, puntiUno, puntiDue, statoPartita, velocitaPalla;

// metodo eseguito al caricamento della vista
- (void)viewDidLoad {
	[super viewDidLoad];
	//impostiamo lo stato iniziale della partita su "fermo"
	self.statoPartita = kPartitaFerma;
	//settiamo la velocità della palla in un componente a due dimensioni
	velocitaPalla = CGPointMake(kVelocitaPallaX, kVelocitaPallaY);
	//avviamo un timer per il movimento della pallina
	[NSTimer scheduledTimerWithTimeInterval:0.05 target:self selector:@selector(gameLoop) userInfo:nil repeats:YES];
}

-(void)gameLoop{
	//controlliamo se la partita è in corso
	if (statoPartita == kPartitaInCorso){
		//muoviamo il centro della pallina, spostandolo con i valori della velocità
		pallina.center = CGPointMake(pallina.center.x + velocitaPalla.x, pallina.center.y + velocitaPalla.y);
		//se il centro è oltre le dimensioni orizzontali della vista, invertiamo la direzione (sempre sull'asse X)
		if (pallina.center.x > self.view.bounds.size.width || pallina.center.x < 0){
			velocitaPalla.x = -velocitaPalla.x;
		}
		//se il centro è oltre le dimensioni verticali della vista, invertiamo la direzione (sempre sull'asse Y)
		if (pallina.center.y > self.view.bounds.size.height || pallina.center.y < 0){
			velocitaPalla.y = -velocitaPalla.y;
		}
	} else {
		//se la partita è ferma facciamo ricomparire la label per avviare il gioco
		if(textInizia.hidden){
			textInizia.hidden = NO;
		}
	}
}

-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event{
	//se la partita è ferma facciamola iniziare
	if(statoPartita == kPartitaFerma){
		textInizia.hidden = YES;
		statoPartita = kPartitaInCorso;
	}
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}


- (void)dealloc {
    [super dealloc];
	[pallina release];
	[barraUno release];
	[barraDue release];
	[puntiUno release];
	[puntiDue release];
	[textInizia release];
}

@end
